Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/BoolValueView.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/BoolValueView.Designer.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/BoolValueView.Designer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/BoolValueView.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/BoolValueView.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/BoolValueView.cs	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/ColumnsVisibilityDialog.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/ColumnsVisibilityDialog.Designer.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/ColumnsVisibilityDialog.Designer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/ColumnsVisibilityDialog.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/ColumnsVisibilityDialog.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/ColumnsVisibilityDialog.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/ComparisonView.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/ComparisonView.Designer.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/ComparisonView.Designer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/ComparisonView.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/ComparisonView.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/ComparisonView.cs	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/DoubleRangeView.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/DoubleRangeView.Designer.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/DoubleRangeView.Designer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/DoubleRangeView.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/DoubleRangeView.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/DoubleRangeView.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/EnhancedStringConvertibleMatrixView.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/EnhancedStringConvertibleMatrixView.Designer.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/EnhancedStringConvertibleMatrixView.Designer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/EnhancedStringConvertibleMatrixView.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/EnhancedStringConvertibleMatrixView.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/EnhancedStringConvertibleMatrixView.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/HeuristicLab.Data.Views-3.3.csproj	(revision 11202)
@@ -133,4 +133,22 @@
       <DependentUpon>IntRangeView.cs</DependentUpon>
     </Compile>
+    <Compile Include="Path Views\DirectoryValueView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Path Views\DirectoryValueView.Designer.cs">
+      <DependentUpon>DirectoryValueView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Path Views\FileValueView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Path Views\FileValueView.Designer.cs">
+      <DependentUpon>FileValueView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Path Views\TextFileView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Path Views\TextFileView.Designer.cs">
+      <DependentUpon>TextFileView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Plugin.cs" />
     <Compile Include="StringConvertibleMatrixColumnVisibilityDialog.cs">
@@ -196,4 +214,9 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Common.Resources\3.3\HeuristicLab.Common.Resources-3.3.csproj">
+      <Project>{0e27a536-1c4a-4624-a65e-dc4f4f23e3e1}</Project>
+      <Name>HeuristicLab.Common.Resources-3.3</Name>
+      <Private>False</Private>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
       <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/IntRangeView.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/IntRangeView.Designer.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/IntRangeView.Designer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/IntRangeView.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/IntRangeView.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/IntRangeView.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/DirectoryValueView.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/DirectoryValueView.Designer.cs	(revision 11202)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/DirectoryValueView.Designer.cs	(revision 11202)
@@ -0,0 +1,96 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Data.Views {
+  partial class DirectoryValueView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(DirectoryValueView));
+      this.openButton = new System.Windows.Forms.Button();
+      this.folderBrowserDialog = new System.Windows.Forms.FolderBrowserDialog();
+      this.stringConvertibleValueView = new HeuristicLab.Data.Views.StringConvertibleValueView();
+      this.SuspendLayout();
+      // 
+      // openButton
+      // 
+      this.openButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.openButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Open;
+      this.openButton.Location = new System.Drawing.Point(167, 0);
+      this.openButton.Name = "openButton";
+      this.openButton.Size = new System.Drawing.Size(24, 24);
+      this.openButton.TabIndex = 3;
+      this.openButton.UseVisualStyleBackColor = true;
+      this.openButton.Click += new System.EventHandler(this.openButton_Click);
+      // 
+      // stringConvertibleValueView
+      // 
+      this.stringConvertibleValueView.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.stringConvertibleValueView.Caption = "StringConvertibleValue View";
+      this.stringConvertibleValueView.Content = null;
+      this.stringConvertibleValueView.LabelVisible = true;
+      this.stringConvertibleValueView.Location = new System.Drawing.Point(4, 2);
+      this.stringConvertibleValueView.Name = "stringConvertibleValueView";
+      this.stringConvertibleValueView.ReadOnly = false;
+      this.stringConvertibleValueView.Size = new System.Drawing.Size(157, 21);
+      this.stringConvertibleValueView.TabIndex = 4;
+      // 
+      // DirectoryValueView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.Controls.Add(this.stringConvertibleValueView);
+      this.Controls.Add(this.openButton);
+      this.Name = "DirectoryValueView";
+      this.Size = new System.Drawing.Size(194, 24);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    protected System.Windows.Forms.Button openButton;
+    protected System.Windows.Forms.FolderBrowserDialog folderBrowserDialog;
+    private StringConvertibleValueView stringConvertibleValueView;
+
+  }
+}
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/DirectoryValueView.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/DirectoryValueView.cs	(revision 11202)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/DirectoryValueView.cs	(revision 11202)
@@ -0,0 +1,60 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Data.Views {
+  [View("DirectoryValueView")]
+  [Content(typeof(DirectoryValue), true)]
+  public partial class DirectoryValueView : ItemView {
+    public new DirectoryValue Content {
+      get { return (DirectoryValue)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public DirectoryValueView() {
+      InitializeComponent();
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      openButton.Enabled = !Locked && !ReadOnly && Content != null;
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        stringConvertibleValueView.Content = null;
+        return;
+      }
+
+      stringConvertibleValueView.Content = Content.StringValue;
+    }
+
+    protected virtual void openButton_Click(object sender, EventArgs e) {
+      if (folderBrowserDialog.ShowDialog(this) != DialogResult.OK) return;
+      Content.Value = folderBrowserDialog.SelectedPath;
+    }
+  }
+}
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/FileValueView.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/FileValueView.Designer.cs	(revision 11202)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/FileValueView.Designer.cs	(revision 11202)
@@ -0,0 +1,93 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Data.Views {
+  partial class FileValueView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.openButton = new System.Windows.Forms.Button();
+      this.openFileDialog = new System.Windows.Forms.OpenFileDialog();
+      this.stringConvertibleValueView = new HeuristicLab.Data.Views.StringConvertibleValueView();
+      this.SuspendLayout();
+      // 
+      // openButton
+      // 
+      this.openButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.openButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Open;
+      this.openButton.Location = new System.Drawing.Point(167, 0);
+      this.openButton.Name = "openButton";
+      this.openButton.Size = new System.Drawing.Size(24, 24);
+      this.openButton.TabIndex = 3;
+      this.openButton.UseVisualStyleBackColor = true;
+      this.openButton.Click += new System.EventHandler(this.openButton_Click);
+      // 
+      // stringConvertibleValueView
+      // 
+      this.stringConvertibleValueView.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.stringConvertibleValueView.Caption = "StringConvertibleValue View";
+      this.stringConvertibleValueView.Content = null;
+      this.stringConvertibleValueView.LabelVisible = true;
+      this.stringConvertibleValueView.Location = new System.Drawing.Point(4, 2);
+      this.stringConvertibleValueView.Name = "stringConvertibleValueView";
+      this.stringConvertibleValueView.ReadOnly = false;
+      this.stringConvertibleValueView.Size = new System.Drawing.Size(157, 21);
+      this.stringConvertibleValueView.TabIndex = 0;
+      // 
+      // FileValueView
+      // 
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Inherit;
+      this.Controls.Add(this.stringConvertibleValueView);
+      this.Controls.Add(this.openButton);
+      this.Name = "FileValueView";
+      this.Size = new System.Drawing.Size(194, 24);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    protected System.Windows.Forms.Button openButton;
+    protected System.Windows.Forms.OpenFileDialog openFileDialog;
+    protected StringConvertibleValueView stringConvertibleValueView;
+  }
+}
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/FileValueView.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/FileValueView.cs	(revision 11202)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/FileValueView.cs	(revision 11202)
@@ -0,0 +1,62 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Data.Views {
+  [View("FileValueView")]
+  [Content(typeof(FileValue), true)]
+  public partial class FileValueView : ItemView {
+    public new FileValue Content {
+      get { return (FileValue)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public FileValueView() {
+      InitializeComponent();
+    }
+
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      openButton.Enabled = !Locked && !ReadOnly && Content != null;
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      if (Content == null) {
+        stringConvertibleValueView.Content = null;
+        return;
+      }
+
+      stringConvertibleValueView.Content = Content.StringValue;
+      openFileDialog.Filter = Content.FileDialogFilter;
+    }
+
+    protected virtual void openButton_Click(object sender, EventArgs e) {
+      openFileDialog.Filter = Content.FileDialogFilter;
+      if (openFileDialog.ShowDialog(this) != DialogResult.OK) return;
+      Content.Value = openFileDialog.FileName;
+    }
+  }
+}
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/TextFileView.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/TextFileView.Designer.cs	(revision 11202)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/TextFileView.Designer.cs	(revision 11202)
@@ -0,0 +1,126 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+
+namespace HeuristicLab.Data.Views {
+  partial class TextFileView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(TextFileView));
+      this.saveButton = new System.Windows.Forms.Button();
+      this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
+      this.fileSystemWatcher = new System.IO.FileSystemWatcher();
+      this.textBox = new System.Windows.Forms.TextBox();
+      ((System.ComponentModel.ISupportInitialize)(this.fileSystemWatcher)).BeginInit();
+      this.SuspendLayout();
+      // 
+      // openButton
+      // 
+      this.openButton.Location = new System.Drawing.Point(365, 0);
+      // 
+      // stringConvertibleValueView
+      // 
+      this.stringConvertibleValueView.Size = new System.Drawing.Size(355, 21);
+      // 
+      // saveButton
+      // 
+      this.saveButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.saveButton.CausesValidation = false;
+      this.saveButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
+      this.saveButton.Location = new System.Drawing.Point(395, 0);
+      this.saveButton.Name = "saveButton";
+      this.saveButton.Size = new System.Drawing.Size(24, 24);
+      this.saveButton.TabIndex = 2;
+      this.saveButton.UseVisualStyleBackColor = true;
+      this.saveButton.Click += new System.EventHandler(this.saveButton_Click);
+      // 
+      // fileSystemWatcher
+      // 
+      this.fileSystemWatcher.EnableRaisingEvents = true;
+      this.fileSystemWatcher.NotifyFilter = ((System.IO.NotifyFilters)((System.IO.NotifyFilters.FileName | System.IO.NotifyFilters.LastWrite)));
+      this.fileSystemWatcher.SynchronizingObject = this;
+      this.fileSystemWatcher.Changed += new System.IO.FileSystemEventHandler(this.fileSystemWatcher_Changed);
+      this.fileSystemWatcher.Created += new System.IO.FileSystemEventHandler(this.fileSystemWatcher_Changed);
+      this.fileSystemWatcher.Deleted += new System.IO.FileSystemEventHandler(this.fileSystemWatcher_Changed);
+      this.fileSystemWatcher.Renamed += new System.IO.RenamedEventHandler(this.fileSystemWatcher_Renamed);
+      // 
+      // textBox
+      // 
+      this.textBox.AcceptsReturn = true;
+      this.textBox.AcceptsTab = true;
+      this.textBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.textBox.Font = new System.Drawing.Font("Courier New", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
+      this.textBox.Location = new System.Drawing.Point(3, 30);
+      this.textBox.Multiline = true;
+      this.textBox.Name = "textBox";
+      this.textBox.ScrollBars = System.Windows.Forms.ScrollBars.Both;
+      this.textBox.Size = new System.Drawing.Size(415, 368);
+      this.textBox.TabIndex = 4;
+      this.textBox.TextChanged += new System.EventHandler(this.textBox_TextChanged);
+      this.textBox.Validated += new System.EventHandler(this.textBox_Validated);
+      // 
+      // TextFileView
+      // 
+      this.Controls.Add(this.textBox);
+      this.Controls.Add(this.saveButton);
+      this.Name = "TextFileView";
+      this.Size = new System.Drawing.Size(421, 401);
+      this.Controls.SetChildIndex(this.saveButton, 0);
+      this.Controls.SetChildIndex(this.textBox, 0);
+      this.Controls.SetChildIndex(this.openButton, 0);
+      this.Controls.SetChildIndex(this.stringConvertibleValueView, 0);
+      ((System.ComponentModel.ISupportInitialize)(this.fileSystemWatcher)).EndInit();
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button saveButton;
+    private System.Windows.Forms.SaveFileDialog saveFileDialog;
+    private System.IO.FileSystemWatcher fileSystemWatcher;
+    private System.Windows.Forms.TextBox textBox;
+  }
+}
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/TextFileView.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/TextFileView.cs	(revision 11202)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Path Views/TextFileView.cs	(revision 11202)
@@ -0,0 +1,247 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Drawing;
+using System.IO;
+using System.Windows.Forms;
+using HeuristicLab.MainForm;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Data.Views {
+  [View("TextFileView")]
+  [Content(typeof(TextFileValue), true)]
+  public sealed partial class TextFileView : FileValueView {
+    private bool fileContentChanged;
+    private bool FileContentChanged {
+      get { return fileContentChanged; }
+      set {
+        if (fileContentChanged != value) {
+          fileContentChanged = value;
+          OnFileContentChanged();
+        }
+      }
+    }
+
+    public new TextFileValue Content {
+      get { return (TextFileValue)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public TextFileView() {
+      InitializeComponent();
+      fileContentChanged = false;
+    }
+
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.StringValue.ValueChanged += Content_FilePathChanged;
+    }
+    protected override void DeregisterContentEvents() {
+      Content.StringValue.ValueChanged -= Content_FilePathChanged;
+      fileSystemWatcher.EnableRaisingEvents = false;
+      base.DeregisterContentEvents();
+    }
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      textBox.ReadOnly = Locked || ReadOnly || Content == null;
+      saveButton.Enabled = !Locked && !ReadOnly && Content != null && FileContentChanged;
+
+      if (Content != null && Content.Exists()) {
+        fileSystemWatcher.Filter = Path.GetFileName(Content.Value);
+        var path = Path.GetDirectoryName(Content.Value);
+        if (string.IsNullOrEmpty(path)) path = Environment.CurrentDirectory;
+        fileSystemWatcher.Path = path;
+      }
+      fileSystemWatcher.EnableRaisingEvents = Content != null && File.Exists(Content.Value) && Visible;
+    }
+
+    protected override void OnVisibleChanged(EventArgs e) {
+      //mkommend: necessary to update the textbox to detect intermediate file changes.
+      if (Visible && Content != null) UpdateTextBox();
+      base.OnVisibleChanged(e);
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      FileContentChanged = false;
+      if (Content == null) {
+        textBox.Text = string.Empty;
+        //mkommend: other properties of the file system watcher cannot be cleared (e.g., path) as this leads to an ArgumentException
+        fileSystemWatcher.EnableRaisingEvents = false;
+        return;
+      }
+      saveFileDialog.Filter = Content.FileDialogFilter;
+      UpdateTextBox();
+    }
+
+    private void Content_FilePathChanged(object sender, EventArgs e) {
+      UpdateTextBox();
+      SetEnabledStateOfControls();
+    }
+
+    private void textBox_TextChanged(object sender, EventArgs e) {
+      FileContentChanged = fileText != textBox.Text;
+    }
+
+    private void OnFileContentChanged() {
+      SetEnabledStateOfControls();
+      textBox.ForeColor = FileContentChanged ? Color.Red : Color.Black;
+    }
+
+    private bool fileSystemWatcherChangedFired = false;
+    private void fileSystemWatcher_Changed(object sender, FileSystemEventArgs e) {
+      //mkommend: cannot react on visible changed, because this event is not fired when the parent control gets visible set to false
+      if (!Visible) return;
+      //FileSystemWatcher may fire multiple events depending on how file changes are implemented in the modifying program
+      //see: http://stackoverflow.com/questions/1764809/filesystemwatcher-changed-event-is-raised-twice
+      if (fileSystemWatcherChangedFired) return;
+      fileSystemWatcherChangedFired = true;
+
+      string newContent = ReadFile(Content.Value);
+      if (newContent == textBox.Text) {
+        fileSystemWatcherChangedFired = false;
+        return;
+      }
+
+      //File created
+      if (e.ChangeType == WatcherChangeTypes.Created) {
+        UpdateTextBox();
+      }
+
+      //File changed
+      else if (e.ChangeType == WatcherChangeTypes.Changed) {
+        string msg = string.Format("The content of the file \"{0}\" has changed.\nDo you want to reload the file?", Content.Value);
+        var result = MessageBox.Show(this, msg, "Reload the file?", MessageBoxButtons.YesNo, MessageBoxIcon.Information);
+        if (result == DialogResult.Yes) {
+          UpdateTextBox();
+        } else {
+          fileText = newContent;
+          FileContentChanged = true;
+        }
+      }
+
+      //File deleted
+      else if (e.ChangeType == WatcherChangeTypes.Deleted) {
+        string msg = string.Format("The file \"{0}\" is not present anymore. Do you want to restore the file from the given content?", Content.Value);
+        var result = MessageBox.Show(this, msg, "Restore file?", MessageBoxButtons.YesNo, MessageBoxIcon.Warning);
+        if (result == DialogResult.Yes) {
+          SaveFile();
+        }
+        UpdateTextBox();
+      }
+      fileSystemWatcherChangedFired = false;
+    }
+
+    private void fileSystemWatcher_Renamed(object sender, RenamedEventArgs e) {
+      //mkommend: cannot react on visible changed, because this event is not fired when the parent control gets visible set to false
+      if (!Visible) return;
+      string msg = string.Format("The file \"{0}\" got renamed to \"{1}\". Do you want to update the file path?", e.OldName, e.Name);
+      var result = MessageBox.Show(this, msg, "Update file path?", MessageBoxButtons.YesNo, MessageBoxIcon.Information);
+      if (result == DialogResult.Yes) {
+        Content.Value = e.FullPath;
+        fileSystemWatcher.Filter = e.Name;
+      }
+      UpdateTextBox();
+    }
+
+    private void SaveFile() {
+      //omit circular events by changing the file from HL
+      fileSystemWatcher.EnableRaisingEvents = false;
+      string path = Content.Value;
+      if (string.IsNullOrEmpty(path)) {
+        if (saveFileDialog.ShowDialog(this) != DialogResult.OK) return;
+        path = saveFileDialog.FileName;
+      }
+
+      WriteFile(path, textBox.Text);
+      Content.Value = path;
+      FileContentChanged = false;
+      fileSystemWatcher.EnableRaisingEvents = true;
+    }
+
+    private void saveButton_Click(object sender, EventArgs e) {
+      SaveFile();
+    }
+
+    private string fileText;
+    private void UpdateTextBox() {
+      if (string.IsNullOrEmpty(Content.Value)) {
+        textBox.Enabled = false;
+        textBox.Text = string.Format("No file path is specified.");
+        return;
+      }
+
+      fileText = ReadFile(Content.Value);
+      if (fileText == null) {
+        textBox.Enabled = false;
+        textBox.Text = string.Format("The specified file \"{0}\" cannot be found.", Content.Value);
+        return;
+      }
+
+      textBox.Enabled = true;
+      textBox.Text = fileText;
+    }
+    private void textBox_Validated(object sender, EventArgs e) {
+      if (!FileContentChanged) return;
+      string msg = string.Format("You have not saved the changes in the file \"{0}\" yet. Do you want to save the changes?", Content.Value);
+      var result = MessageBox.Show(this, msg, "Save changes?", MessageBoxButtons.YesNo, MessageBoxIcon.Information);
+      if (result == DialogResult.Yes) SaveFile();
+    }
+
+    protected override bool ProcessCmdKey(ref Message msg, Keys keyData) {
+      if (keyData == (Keys.Control | Keys.S)) {
+        SaveFile();
+        return true;
+      }
+      return base.ProcessCmdKey(ref msg, keyData);
+    }
+
+    private static string ReadFile(string path) {
+      if (!File.Exists(path)) return null;
+      string fileContent = string.Empty;
+      try {
+        using (FileStream fileStream = new FileStream(path, FileMode.Open, FileAccess.Read, FileShare.ReadWrite)) {
+          using (StreamReader streamReader = new StreamReader(fileStream)) {
+            fileContent = streamReader.ReadToEnd();
+          }
+        }
+      }
+      catch (Exception e) {
+        ErrorHandling.ShowErrorDialog(e);
+      }
+      return fileContent;
+    }
+
+    private static void WriteFile(string path, string fileContent) {
+      try {
+        using (FileStream fileStream = new FileStream(path, FileMode.Create, FileAccess.Write, FileShare.None)) {
+          using (StreamWriter streamWriter = new StreamWriter(fileStream)) {
+            streamWriter.Write(fileContent);
+          }
+        }
+      }
+      catch (Exception e) {
+        ErrorHandling.ShowErrorDialog(e);
+      }
+    }
+  }
+}
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Plugin.cs.frame
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Plugin.cs.frame	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Plugin.cs.frame	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -29,7 +29,8 @@
   /// Plugin class for HeuristicLab.Data.Views plugin.
   /// </summary>
-  [Plugin("HeuristicLab.Data.Views", "3.3.7.$WCREV$")]
+  [Plugin("HeuristicLab.Data.Views", "3.3.10.$WCREV$")]
   [PluginFile("HeuristicLab.Data.Views-3.3.dll", PluginFileType.Assembly)]
   [PluginDependency("HeuristicLab.Common", "3.3")]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Core.Views", "3.3")]
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Properties/AssemblyInfo.cs.frame
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Properties/AssemblyInfo.cs.frame	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/Properties/AssemblyInfo.cs.frame	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -32,5 +32,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2002-2012 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2014 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
@@ -54,3 +54,3 @@
 // by using the '*' as shown below:
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.7.$WCREV$")]
+[assembly: AssemblyFileVersion("3.3.10.$WCREV$")]
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.Designer.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.Designer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleArrayView.cs	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -53,4 +53,5 @@
 
     protected override void DeregisterContentEvents() {
+      Content.ElementNamesChanged -= new EventHandler(Content_ElementNamesChanged);
       Content.ItemChanged -= new EventHandler<EventArgs<int>>(Content_ItemChanged);
       Content.Reset -= new EventHandler(Content_Reset);
@@ -62,4 +63,5 @@
       Content.ItemChanged += new EventHandler<EventArgs<int>>(Content_ItemChanged);
       Content.Reset += new EventHandler(Content_Reset);
+      Content.ElementNamesChanged += new EventHandler(Content_ElementNamesChanged);
     }
 
@@ -96,5 +98,25 @@
         dataGridView.Columns[0].Width = dataGridView.Columns[0].GetPreferredWidth(DataGridViewAutoSizeColumnMode.AllCells, true);
       }
+      UpdateRowHeaders();
+      dataGridView.AutoResizeRowHeadersWidth(DataGridViewRowHeadersWidthSizeMode.AutoSizeToDisplayedHeaders);
       dataGridView.Enabled = true;
+    }
+
+    protected virtual void UpdateRowHeaders() {
+      int i = 0;
+      foreach (string elementName in Content.ElementNames) {
+        dataGridView.Rows[i].HeaderCell.Value = elementName;
+        i++;
+      }
+      for (; i < dataGridView.RowCount; i++) {
+        dataGridView.Rows[i].HeaderCell.Value = string.Empty;
+      }
+    }
+
+    private void Content_ElementNamesChanged(object sender, EventArgs e) {
+      if (InvokeRequired)
+        Invoke(new EventHandler(Content_ElementNamesChanged), sender, e);
+      else
+        UpdateRowHeaders();
     }
 
@@ -103,4 +125,7 @@
         Invoke(new EventHandler<EventArgs<int>>(Content_ItemChanged), sender, e);
       else {
+        // if a resize of the array occurs and some other class handles the event and provides default values
+        //then the itemChanged will occur before the reset event. hence the check was added
+        if (dataGridView.RowCount <= e.Value) return;
         dataGridView.Rows[e.Value].Cells[0].Value = Content.GetValue(e.Value);
         Size size = dataGridView.Rows[e.Value].Cells[0].PreferredSize;
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixColumnVisibilityDialog.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixColumnVisibilityDialog.Designer.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixColumnVisibilityDialog.Designer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixColumnVisibilityDialog.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixColumnVisibilityDialog.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixColumnVisibilityDialog.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixRowVisibilityDialog.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixRowVisibilityDialog.Designer.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixRowVisibilityDialog.Designer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixRowVisibilityDialog.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixRowVisibilityDialog.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixRowVisibilityDialog.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.Designer.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.Designer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixView.cs	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -36,5 +36,5 @@
   public partial class StringConvertibleMatrixView : AsynchronousContentView {
     protected int[] virtualRowIndices;
-    private List<KeyValuePair<int, SortOrder>> sortedColumnIndices;
+    protected List<KeyValuePair<int, SortOrder>> sortedColumnIndices;
     private RowComparer rowComparer;
 
@@ -261,5 +261,5 @@
 
     #region DataGridView Events
-    private void dataGridView_CellValidating(object sender, DataGridViewCellValidatingEventArgs e) {
+    protected virtual void dataGridView_CellValidating(object sender, DataGridViewCellValidatingEventArgs e) {
       if (!dataGridView.ReadOnly) {
         string errorMessage;
@@ -270,5 +270,5 @@
       }
     }
-    private void dataGridView_CellParsing(object sender, DataGridViewCellParsingEventArgs e) {
+    protected virtual void dataGridView_CellParsing(object sender, DataGridViewCellParsingEventArgs e) {
       if (!dataGridView.ReadOnly) {
         string value = e.Value.ToString();
@@ -340,4 +340,6 @@
 
       for (int i = minRowIndex; i <= maxRowIndex; i++) {
+        if (!dataGridView.Rows[i].Visible) continue;
+
         int rowIndex = this.virtualRowIndices[i];
         if (addRowNames) {
@@ -362,5 +364,5 @@
     }
 
-    private void PasteValuesToDataGridView() {
+    protected virtual void PasteValuesToDataGridView() {
       string[,] values = SplitClipboardString(Clipboard.GetText());
       int rowIndex = 0;
@@ -430,5 +432,5 @@
     }
 
-    private void Sort() {
+    protected void Sort() {
       virtualRowIndices = Sort(sortedColumnIndices);
       UpdateSortGlyph();
@@ -515,4 +517,5 @@
     protected virtual void ShowHideColumns_Click(object sender, EventArgs e) {
       new StringConvertibleMatrixColumnVisibilityDialog(this.dataGridView.Columns.Cast<DataGridViewColumn>()).ShowDialog();
+      columnsTextBox.Text = dataGridView.Columns.GetColumnCount(DataGridViewElementStates.Visible).ToString();
     }
 
@@ -539,5 +542,5 @@
     }
 
-    private void dataGridView_SelectionChanged(object sender, EventArgs e) {
+    protected virtual void dataGridView_SelectionChanged(object sender, EventArgs e) {
       string stringFormat = "{0,20:0.0000}";
       statisticsTextBox.Text = string.Empty;
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixVisibilityDialog.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixVisibilityDialog.Designer.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixVisibilityDialog.Designer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixVisibilityDialog.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixVisibilityDialog.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleMatrixVisibilityDialog.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueTupleView.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueTupleView.Designer.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueTupleView.Designer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueTupleView.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueTupleView.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueTupleView.cs	(revision 11202)
@@ -1,5 +1,5 @@
 ﻿#region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueView.Designer.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueView.Designer.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueView.Designer.cs	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -124,8 +124,8 @@
     #endregion
 
-    private System.Windows.Forms.TextBox valueTextBox;
-    private System.Windows.Forms.ErrorProvider errorProvider;
-    private System.Windows.Forms.Label valueLabel;
-    private System.Windows.Forms.SplitContainer splitContainer;
+    protected System.Windows.Forms.TextBox valueTextBox;
+    protected System.Windows.Forms.ErrorProvider errorProvider;
+    protected System.Windows.Forms.Label valueLabel;
+    protected System.Windows.Forms.SplitContainer splitContainer;
   }
 }
Index: branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueView.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueView.cs	(revision 9522)
+++ branches/HiveStatistics/sources/HeuristicLab.Data.Views/3.3/StringConvertibleValueView.cs	(revision 11202)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -78,5 +78,5 @@
     }
 
-    private void Content_ValueChanged(object sender, EventArgs e) {
+    protected virtual void Content_ValueChanged(object sender, EventArgs e) {
       if (InvokeRequired)
         Invoke(new EventHandler(Content_ValueChanged), sender, e);
@@ -85,5 +85,5 @@
     }
 
-    private void valueTextBox_KeyDown(object sender, KeyEventArgs e) {
+    protected virtual void valueTextBox_KeyDown(object sender, KeyEventArgs e) {
       if ((e.KeyCode == Keys.Enter) || (e.KeyCode == Keys.Return))
         valueLabel.Select();  // select label to validate data
@@ -94,5 +94,5 @@
       }
     }
-    private void valueTextBox_Validating(object sender, CancelEventArgs e) {
+    protected virtual void valueTextBox_Validating(object sender, CancelEventArgs e) {
       if (ReadOnly) return;
       string errorMessage;
@@ -103,5 +103,5 @@
       }
     }
-    private void valueTextBox_Validated(object sender, EventArgs e) {
+    protected virtual void valueTextBox_Validated(object sender, EventArgs e) {
       if (ReadOnly) return;
       if (!Content.ReadOnly) Content.SetValue(valueTextBox.Text);
